package ProjectTankHard.DrawningObjects;

import ProjectTankHard.Entities.EntityTank;

import java.awt.*;

public class DrawningTank extends DrawningTankBase {
    public DrawningTank(int speed, double weight, Color bodyColor, Color additionalColor,
                        boolean isAntiAirforceGun, boolean isTankTower, int width, int height){
        super(speed, weight, bodyColor, width, height);

        if(EntityTankBase() != null){
            EntityTankBase = new EntityTank(speed, weight, bodyColor, additionalColor, isAntiAirforceGun, isTankTower);
        }
    }

    @Override
    public void DrawTank(Graphics2D g2d){
        if (!(EntityTankBase instanceof EntityTank)) return;

        super.DrawTank(g2d);

        EntityTank _tank = (EntityTank) EntityTankBase;
        g2d.setColor(_tank.AdditionalColor());

        // дуло
        if (_tank.IsTankTower()) {
            g2d.fillRect(_startPosX + 15, _startPosY + 37, 30, 7);
        }

        if (_tank.IsAntiAirforceGun()) {
            // зенитное орудие
            g2d.drawRect(_startPosX + 65, _startPosY + 18, 8, 12);
            g2d.drawRect(_startPosX + 65 + 8, _startPosY + 16, 8, 14);

            int[] xLeft = {_startPosX + 52, _startPosX + 67, _startPosX + 67 + 5, _startPosX + 57};
            int[] yLeft = {_startPosY + 5, _startPosY + 18, _startPosY + 18, _startPosY + 5};

            g2d.drawPolygon(xLeft, yLeft, xLeft.length);

            int[] xRight = {_startPosX + 59, _startPosX + 74, _startPosX + 74 + 5, _startPosX + 66};
            int[] yRight = {_startPosY, _startPosY + 16, _startPosY + 16, _startPosY};

            g2d.drawPolygon(xRight, yRight, xRight.length);
        }
    }
}
