package ProjectTankHard;

import ProjectTankHard.DrawningObjects.DrawningTank;
import ProjectTankHard.DrawningObjects.DrawningTankBase;
import ProjectTankHard.DrawningObjects.DrawningWheels;
import ProjectTankHard.MovementStrategy.*;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Random;

public class FormTank {
    public DrawningTankBase DrawningTankBase;
    private AbstractStrategy _abstractStrategy;
    Canvas canv;
    static int pictureBoxWidth = 882;
    static int pictureBoxHeight = 453;
    public void Draw(){
        canv.repaint();
    }
    public FormTank() {
        JFrame TankFrame = new JFrame();

        JButton RightButton = new JButton(new ImageIcon("resources/RightButton.png"));
        JButton LeftButton = new JButton(new ImageIcon("resources/LeftButton.png"));
        JButton UpButton = new JButton(new ImageIcon("resources/UpButton.png"));
        JButton DownButton = new JButton(new ImageIcon("resources/DownButton.png"));
        JButton CreateTankBaseButton = new JButton("Создать (прост.)");
        JButton CreateTankButton = new JButton("Создать (продв.)");

        JButton StepButton = new JButton("Шаг");
        JComboBox StrategyComboBox = new JComboBox(new String[]{ "Довести до центра", "Довести до края"});

        TankFrame.setSize (900, 500);
        TankFrame.setDefaultCloseOperation (JFrame.EXIT_ON_CLOSE);
        TankFrame.setLayout(null);

        canv = new Canvas();
        canv.setSize(pictureBoxWidth, pictureBoxHeight);

        CreateTankBaseButton.setBounds(198, 401, 180, 40);
        CreateTankButton.setBounds(12, 401, 180, 40);
        RightButton.setBounds(840,411,30,30);
        LeftButton.setBounds(768,411,30,30);
        UpButton.setBounds(804,375,30,30);
        DownButton.setBounds(804,411,30,30);
        StrategyComboBox.setBounds(719,12,151,28);
        StepButton.setBounds(768, 46, 94, 29);

        TankFrame.add(canv);
        TankFrame.add(CreateTankBaseButton);
        TankFrame.add(CreateTankButton);
        TankFrame.add(RightButton);
        TankFrame.add(LeftButton);
        TankFrame.add(UpButton);
        TankFrame.add(DownButton);
        TankFrame.add(StrategyComboBox);
        TankFrame.add(StepButton);

        StepButton.addActionListener(
            new ActionListener() {
                public void actionPerformed(ActionEvent e){
                    if (DrawningTankBase == null) return;

                    if (StrategyComboBox.isEnabled())
                    {
                        switch (StrategyComboBox.getSelectedIndex())
                        {
                            case 0:
                                _abstractStrategy = new MoveToCenter();
                                break;
                            case 1:
                                _abstractStrategy = new MoveToBorder();
                                break;
                            default:
                                _abstractStrategy = null;
                                break;
                        };

                        if (_abstractStrategy == null) return;

                        _abstractStrategy.SetData(new DrawningObjectTank(DrawningTankBase), pictureBoxWidth, pictureBoxHeight);
                        StrategyComboBox.setEnabled(false);
                    }

                    if (_abstractStrategy == null) return;

                    _abstractStrategy.MakeStep();
                    Draw();

                    if (_abstractStrategy.GetStatus() == Status.Finish)
                    {
                        StrategyComboBox.setEnabled(true);
                        _abstractStrategy = null;
                    }
                }
            }
        );

        Random random = new Random();
        CreateTankBaseButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                DrawningTankBase = new DrawningTankBase(random.nextInt(100, 300), random.nextDouble(1000, 3000),
                        Color.getHSBColor(random.nextInt(0, 301), random.nextInt(0, 301), random.nextInt(0, 301)),
                        pictureBoxWidth, pictureBoxHeight);

                DrawningTankBase.SetPosition(random.nextInt(0, 100), random.nextInt(0, 100));

                canv.DrawningTankBase = DrawningTankBase;
                StrategyComboBox.enable(true);
                Draw();
            }
        });

        CreateTankButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                DrawningTankBase = new DrawningTank(random.nextInt(100, 300), random.nextDouble(1000, 3000),
                        Color.getHSBColor(random.nextInt(0, 301), random.nextInt(0, 301), random.nextInt(0, 301)),
                        Color.getHSBColor(random.nextInt(0, 301), random.nextInt(0, 301), random.nextInt(0, 301)),
                        random.nextBoolean(), random.nextBoolean(), pictureBoxWidth, pictureBoxHeight);

                DrawningTankBase.SetPosition(random.nextInt(0, 100), random.nextInt(0, 100));

                canv.DrawningTankBase = DrawningTankBase;
                StrategyComboBox.enable(true);
                Draw();
            }
        });

        RightButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                if (DrawningTankBase.EntityTankBase() == null)
                    return;
                DrawningTankBase.MoveTransport(DirectionType.Right);
                Draw();
            }
        });

        LeftButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                if (DrawningTankBase.EntityTankBase() == null)
                    return;
                DrawningTankBase.MoveTransport(DirectionType.Left);
                Draw();
            }
        });

        UpButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                if (DrawningTankBase.EntityTankBase() == null)
                    return;
                DrawningTankBase.MoveTransport(DirectionType.Up);
                Draw();
            }
        });

        DownButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                if (DrawningTankBase.EntityTankBase() == null)
                    return;
                DrawningTankBase.MoveTransport(DirectionType.Down);
                Draw();
            }
        });

        TankFrame.setVisible(true);
    }
}

class Canvas extends JComponent{
    public DrawningTankBase DrawningTankBase;
    public Canvas(){
    }
    public void paintComponent (Graphics g){
        if (DrawningTankBase == null){
            return;
        }
        super.paintComponents (g) ;
        Graphics2D g2d = (Graphics2D)g;
        DrawningTankBase.DrawTank(g2d);
        super.repaint();
    }
}
