package ProjectTankHard.MovementStrategy;

import ProjectTankHard.DirectionType;
import ProjectTankHard.DrawningObjects.DrawningTankBase;

public class DrawningObjectTank implements IMoveableObject{
    private final DrawningTankBase _drawningTankBase;
    public DrawningObjectTank(DrawningTankBase drawningTankBase){
        _drawningTankBase = drawningTankBase;
    }
    public ObjectParameters GetObjectParameters(){
        if(_drawningTankBase == null || _drawningTankBase.EntityTankBase() == null)
            return null;
        return new ObjectParameters(_drawningTankBase.GetPosX(), _drawningTankBase.GetPosY(),
                _drawningTankBase.GetWidth(), _drawningTankBase.GetHeight());
    }
    public int GetStep(){
        if(_drawningTankBase.EntityTankBase() == null)
            return 0;
        return (int)_drawningTankBase.EntityTankBase().Step();
    }

    public boolean CheckCanMove(DirectionType direction){
        if(_drawningTankBase == null)
            return false;
        return _drawningTankBase.CanMove(direction);
    }

    public void MoveObject(DirectionType direction){
        if(_drawningTankBase == null)
            return;
        _drawningTankBase.MoveTransport(direction);
    }
}
